C for ODF3_1 10/04/2012

C SUBROUTINE-FUNCTION INTEGRAND 
C for simulation with analitical equation, 2-nd order,
c coinsided tenzors(ESRMOD1)
        SUBROUTINE FUNC1(NTOCH,NUMINT,ANGLES,FUNS)
       IMPLICIT DOUBLE PRECISION (A-H),DOUBLE PRECISION (O-Z)       
C
       include 'NumParam.inc'
       parameter(absolut=1.0d-15 )

       DIMENSION ANGLES(3),FUNS(NUMPOINT)
       DOUBLE PRECISION ANGLES, FUNS
       dimension  prompo1(MAXNUCL,MAXTRAN)
       dimension sl2(MAXNUCL),SL3(MAXNUCL),SL4(MAXNUCL) 
       dimension e(3),estr(3), ABG(3,3)   
c                          
       common/res/ResField(NUMPOINT),ResSpec(NUMPOINT),delta
       common/value1/spin(MAXNUCL),spinm(MAXNUCL,MAXNUCL),
     *GN(MAXNUCL),DELF, HSRED,Fscale,EPS,TNET(2),XL(3,2)
       common/value11/ncomp(MAXNUCL),IEQ(MAXNUCL)
 
       common/value2/spinm2(MAXNUCL,MAXNUCL),prspin(MAXNUCL,MAXNUCL)
       common/old1/HW,HWBET,gausM(3,3),aLorM(3,3)
       common/old11/nucl1,nucl2,Kshape1,Kshape2,Kfft

       common /APROM/G2X,G2Y,g2Z,A2X(MAXNUCL),A2Y(MAXNUCL),A2Z(MAXNUCL),
     +  GA2X(MAXNUCL),GA2Y(MAXNUCL),GA2Z(MAXNUCL)

      parameter (be=4.6688D-5)

      common/hi/eHi(3)
      common/ODF1/Jmax

C Integtation  - in the frame ODF (g-tensor frame, denoted gF)
C The angles (alfa, betta, gamma)transfer the g-frame to the sample frame
C ABG - direction cosine for sample axes in gF frame
        call EulerMat(ANGLES,s2,c2,ABG)
C Magnetic field is directed along z of the laboratory frame (the cosines      {0,1,0})
C Microwave magnetic field H1 is directed along x-axis of the laboratory frame (cosines {1,0,0}
C x-axes of sample frame and laboratory frame coincide 
C    hi - angle of the sample turn around X
C eHi- direction cosines for magnetic field in the sample frame are {0,cos(hi),-sin(hi)}

C e(i)- direction cosine for magnetic field H in gF
       e(1)=ABG(1,1)*eHi(1)+ABG(1,2)*eHi(2)+ABG(1,3)*eHi(3)
       e(2)=ABG(2,1)*eHi(1)+ABG(2,2)*eHi(2)+ABG(2,3)*eHi(3)
       e(3)=ABG(3,1)*eHi(1)+ABG(3,2)*eHi(2)+ABG(3,3)*eHi(3) 

C estr(i)- direction cosine for magnetic field H1 in gF
       estr(1)=ABG(1,1)
       estr(2)=ABG(2,1)
       estr(3)=ABG(3,1) 

       CALL LineWidth(Ilabel,delga,dellor,dellor2,OEFFF,OEFF1,e)

C
c Spectrum is calculated with equation (3.110), p.120, Gidomirov
c This  equation is for weak external field and coinsided A- and g-tenzors
              
       raznost=1.d0-dabs(e(3))
       if(raznost.LE.absolut) then
       COTET=1.d0   !!! TETA=0
       COSFI=1.d0   !!! FI is arbitrary
       else
       COTET=e(3)
       COSFI=e(2)/dsin(dacos(e(3)))
      end if 
       
          CO2TET=COTET*COTET
            CO2FI=COSFI*COSFI 

      G2PERP=G2X+(G2Y-G2X)*CO2FI
              g2eff=G2perp+(G2Z-G2PERP)*CO2TET
c !formula (3.38) in Gidomirov!
          WW=(G2X*G2Y*(estr(1)*e(2)-e(1)*estr(2))**2+
     *        G2Y*G2Z*(estr(2)*e(3)-e(2)*estr(3))**2+
     *        G2Z*G2X*(estr(3)*e(1)-e(3)*estr(1))**2)/G2EFF/4.D0 

       geff=dsqrt(g2eff)



       sl1=hwbet/geff !slag1-4 - (3.110), p.120 in Gidomirov        
          do i=1,nucl1
      GA2PERP=GA2X(i)+(GA2Y(i)-GA2X(i))*CO2FI

      A2PERP=GA2PERP/G2PERP
      onst2=((GA2Z(i)-GA2perp)*CO2TET+GA2perp)/g2eff
          sl2(i)=DSQRT(onst2)/GEFF/BE
c       if (A2perp.eq.0) then
c      write(*,*)GA2perp,nucl1,cosfi
c      write(*,*)ga2x(I),ga2y(i)
c        stop
c           endif
      sl3(i)=(A2X(I)*A2Y(I)/A2PERP+A2Z(I)*A2PERP/ONST2+(A2PERP-A2X(I))*
     +(A2Y(I)-A2PERP)*GA2Z(I)*CO2TET/A2PERP/ONST2/G2EFF)/GEFF/BE/4.d0/HW
      sl4(I)=2.D0*((A2PERP-A2X(I))*(A2Y(I)-A2PERP)*G2PERP*(1.D0-CO2TET)
     +/G2EFF/ONST2+(ONST2-A2PERP)*(A2Z(I)-ONST2)/ONST2)/GEFF/BE/4.d0/HW     
          end do 
C       PAUSE
C    ANISOTROPIC COUPLINGS
       klu1=1
      do 12 numnucl=1,nucl1
        klu=0
          do 11 j=1,ncomp(numnucl) 
         slag2=spinm(numnucl,j)*sl2(numnucl)                 
         slag3=SL3(NUMNUCL)*prspin(numnucl,j)
         slag4=SL4(NUMNUCL)*spinm2(numnucl,j) 
         SLAG=slag2+slag3+slag4
            do 11 j1=1,klu1 
            klu=klu+1
            prompo1(numnucl+1,klu)=
     +      prompo1(numnucl,j1)-SLAG
   11   continue
   12     KLU1=KLU 
         DO IINT=1,NTOCH
              FUNS(IINT)=0.d0 
         END DO
c
              do 20 j=1,klu1
                  SLL=sl1+prompo1(nucl1+1,j)
                  DO 20 IINT=1,NTOCH
                        po1=RESField(IINT)- SLL

        CALL LineShape(Ilabel,delga,dellor,dellor2,OEFF1,po1,F2)
                        FUNS(IINT)=FUNS(IINT)+F2
  20   continue 
       
             call DISTFUN(Jmax,c2,angles(3),RO)
      
       DO IINT=1,NTOCH
       FUNS(IINT)=FUNS(IINT)*RO*s2*OEFFF*WW/dfloat(klu1)     
       END DO 

       if      (Ilabel.eq.202) then
c here CONVOLUTION BY FFT
         call gconvl(FUNS,delga,delta,NTOCH)
       endif
       RETURN
       END
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
