C for ODF3_1 10/04/2012

C SUBROUTINE-FUNCTION INTEGRAND 
C for simulation with analitical equation, 2-nd order,
c coinsided tenzors(ESRMOD1)
        SUBROUTINE FUNC1t(NTOCH,NUMINT,ANGLES,FUNS)
       IMPLICIT DOUBLE PRECISION (A-H),DOUBLE PRECISION (O-Z)       
C
       include 'NumParam.inc'
       parameter  (absolut=1.0d-15 )

c       include 'MATDIM.inc'

       DIMENSION ANGLES(3),FUNS(NUMPOINT),F2(NUMPOINT)
       dimension  prompo1(MAXNUCL+1,MAXTRAN)
       dimension sl2(MAXNUCL),SL3(MAXNUCL),SL4(MAXNUCL) 
       dimension  e(3),estr(3),e2(3),ABG(3,3) 
c                          
       common/res/ResField(NUMPOINT),ResSpec(NUMPOINT),delta
       common/value1/spin(MAXNUCL),spinm(MAXNUCL,MAXNUCL),
     * GN(MAXNUCL),DELF, HSRED,Fscale,EPS,TNET(2),XL(3,2)
       common/value11/ncomp(MAXNUCL),IEQ(MAXNUCL)

       common/value2/spinm2(MAXNUCL,MAXNUCL),prspin(MAXNUCL,MAXNUCL)
       common/old1/HW,HWBET,gausM(3,3),aLorM(3,3)
       common/old11/nucl1,nucl2,Kshape1,Kshape2,Kfft

       common /APROM/G2X,G2Y,g2Z,A2X(MAXNUCL),A2Y(MAXNUCL),A2Z(MAXNUCL),
     +  GA2X(MAXNUCL),GA2Y(MAXNUCL),GA2Z(MAXNUCL)
       common/promsig/ promsigxG(MAXNUCL+1,MAXTRAN),
     * promsigyG(MAXNUCL+1,MAXTRAN),promsigzG(MAXNUCL+1,MAXTRAN),
     * promsigxL(MAXNUCL+1,MAXTRAN),promsigyL(MAXNUCL+1,MAXTRAN),
     * promsigzL(MAXNUCL+1,MAXTRAN)
c
       DOUBLE COMPLEX promc,arg,argz,erffun
c
      double precision PI
      parameter (PI=3.1415926535897932384626433832795D0)
      parameter (SQTWO=1.4142135623730950488016887242097D0)
      parameter (SQTHREE=1.7320508075688772935274463415059D0)
      parameter (SQPI=1.7724538509055160272981674833411D0)
c      DOUBLE COMPLEX, parameter::im=(0.d0,1.d0)
c
      parameter (OEFFG=SQTWO/SQPI/PI) !OEFFG= DSQRT(2.d0/PI)/PI  
      parameter(OEFFL=SQTHREE/(2.0d0*PI*PI)) !OEFFL= DSQRT(3.d0)/(2*PI*PI)
      parameter ( OEFF1L= 3.d0/4.d0) 
      parameter (OEFFC=2.d0/SQPI/PI) !OEFFC= 2.0d0/DSQRT(PI)/PI  
      parameter ( OEFF2C= SQTHREE/SQTWO) 
      parameter (be=4.6688D-5, coe=PI/180.d0)
C

      common/hi/eHi(3)
      common/ODF1/Jmax
      common /Ilabel/Ilabel

      
Comments see Func1      
        call EulerMat(ANGLES,s2,c2,ABG)
  
       e(1)=ABG(1,1)*eHi(1)+ABG(1,2)*eHi(2)+ABG(1,3)*eHi(3)
       e(2)=ABG(2,1)*eHi(1)+ABG(2,2)*eHi(2)+ABG(2,3)*eHi(3)
       e(3)=ABG(3,1)*eHi(1)+ABG(3,2)*eHi(2)+ABG(3,3)*eHi(3) 

C estr(i)- direction cosine for magnetic field H1 in gF
       estr(1)=ABG(1,1)
       estr(2)=ABG(2,1)
       estr(3)=ABG(3,1) 

c Spectrum is calculated with equation (3.110), p.120, Gidomirov
c This  equation is for weak external field and coinsided A- and g-tenzors
 
       raznost=1.d0-dabs(e(3))
       if(raznost.LE.absolut) then
       COTET=1.d0   !!! TETA=0
       COSFI=1.d0   !!! FI is arbitrary
      else
       COTET=e(3)
       COSFI=e(2)/dsin(dacos(e(3)))
      end if 
       
          CO2TET=COTET*COTET
            CO2FI=COSFI*COSFI

      e2(1)=e(1)*e(1)
      e2(2)=e(2)*e(2)
      e2(3)=e(3)*e(3)

            G2PERP=G2X+(G2Y-G2X)*CO2FI
            g2eff=G2perp+(G2Z-G2PERP)*CO2TET
c !formula (3.38) in Gidomirov!
          WW=(G2X*G2Y*(estr(1)*e(2)-e(1)*estr(2))**2+
     *        G2Y*G2Z*(estr(2)*e(3)-e(2)*estr(3))**2+
     *        G2Z*G2X*(estr(3)*e(1)-e(3)*estr(1))**2)/G2EFF/4.D0 

            geff=dsqrt(g2eff)

c
       sl1=hwbet/geff 
          do i=1,nucl1
      GA2PERP=GA2X(i)+(GA2Y(i)-GA2X(i))*CO2FI
      A2PERP=GA2PERP/G2PERP
      onst2=((GA2Z(i)-GA2perp)*CO2TET+GA2perp)/g2eff
          sl2(i)=DSQRT(onst2)/GEFF/BE

      sl3(i)=(A2X(I)*A2Y(I)/A2PERP+A2Z(I)*A2PERP/ONST2+(A2PERP-A2X(I))*
     +(A2Y(I)-A2PERP)*GA2Z(I)*CO2TET/A2PERP/ONST2/G2EFF)/GEFF/BE/4.d0/HW
      sl4(I)=2.D0*((A2PERP-A2X(I))*(A2Y(I)-A2PERP)*G2PERP*(1.D0-CO2TET)
     +/G2EFF/ONST2+(ONST2-A2PERP)*(A2Z(I)-ONST2)/ONST2)/GEFF/BE/4.d0/HW     
          end do 
C       PAUSE
C    ANISOTROPIC COUPLINGS

          do  j=1,ncomp(1) 
             prompo1(1,j)=0.d0
          enddo
c
       klu1=1
      do 12 numnucl=1,nucl1
        klu=0
          do 11 j=1,ncomp(numnucl) 
         slag2=spinm(numnucl,j)*sl2(numnucl)                 
         slag3=SL3(NUMNUCL)*prspin(numnucl,j)
         slag4=SL4(NUMNUCL)*spinm2(numnucl,j) 
         SLAG=slag2+slag3+slag4
            do 11 j1=1,klu1 
            klu=klu+1
            prompo1(numnucl+1,klu)=
     +      prompo1(numnucl,j1)-SLAG
   11   continue
   12     KLU1=KLU 

         DO IINT=1,NTOCH
              FUNS(IINT)=0.d0 
         END DO  
      
              do 20 j=1,klu1
                  SLL=sl1+prompo1(nucl1+1,j)
       SELECT CASE (Ilabel)
c dellin is calculated by (3.25), p.112, Rakitin
       case (101)
        delga2=(e2(1)*promsigxG(nucl1+1,j)+e2(2)*promsigyG(nucl1+1,j)+
     *        e2(3)*promsigzG(nucl1+1,j))/g2eff 
        delga=dsqrt(delga2)
             OEFFF=OEFFG/delga
               OEFF1=-2.d0/delga2  
       case (201)
       dellor2=(e2(1)*promsigxL(nucl1+1,j)+e2(2)*promsigyL(nucl1+1,j)+
     *        e2(3)*promsigzL(nucl1+1,j))/g2eff 
        dellor=dsqrt(dellor2)
                  OEFFF=dellor*OEFFL
              OEFF1=OEFF1L*dellor2
       case (202)
        delga2=(e2(1)*promsigxG(nucl1+1,j)+e2(2)*promsigyG(nucl1+1,j)+
     *        e2(3)*promsigzG(nucl1+1,j))/g2eff 
        dellor2=(e2(1)*promsigxL(nucl1+1,j)+e2(2)*promsigyL(nucl1+1,j)+
     *        e2(3)*promsigzL(nucl1+1,j))/g2eff 
        delga=dsqrt(delga2)
        dellor=dsqrt(dellor2)
                   OEFFF=dellor*OEFFL
              OEFF1=OEFF1L*dellor2
       case (301)
       delga2=(e2(1)*promsigxG(nucl1+1,j)+e2(2)*promsigyG(nucl1+1,j)+
     *        e2(3)*promsigzG(nucl1+1,j))/g2eff 
        dellor2=(e2(1)*promsigxL(nucl1+1,j)+e2(2)*promsigyL(nucl1+1,j)+
     *        e2(3)*promsigzL(nucl1+1,j))/g2eff 
        delga=dsqrt(delga2)
        dellor=dsqrt(dellor2)
                  OEFFF=OEFFC/delga2
        END SELECT
        
        DO 21 IINT=1,NTOCH
            po1=RESField(IINT)- SLL
          SELECT CASE (Ilabel)
                  case (101)
C forma linii - gauss,in differential form
                     po2=oeff1*po1*po1
                     F2(IINT)=-OEFF1*PO1*EXP(PO2)
             case (201:202)
C forma linii - lorench (differential form)
                            PROM=PO1*PO1+OEFF1
                        F2(IINT)=PO1/(PROM*PROM) 
             case (301)
C FORMA LINII - CONVOLUTION OF GAUSS AND LORENTZ
         argz=cmplx(PO1*SQTWO/delga,OEFF2C*dellor/delga)
         arg=-argz*(0.d0,1.d0) 
         call dcerfc(1,arg,erffun)             
         promc=argz*erffun  
               F2(IINT)=dreal(promc)
          END SELECT
  21    CONTINUE 
        IF (Ilabel.EQ.202) then
c here CONVOLUTION BY FFT
             call gconvl(F2,delga,delta,NTOCH)
        ENDIF
        DO IINT=1,NTOCH ! spectrum   
           FUNS(IINT)=FUNS(IINT)+OEFFF*F2(IINT)
        ENDDO
  20   continue  
  
      call DISTFUN(Jmax,c2,angles(3),RO)
       
       DO IINT=1,NTOCH
       FUNS(IINT)=FUNS(IINT)*RO*s2*WW/dfloat(klu1)
       END DO       
      
c      call promout(ntoch,AField,Funs)      

       RETURN
       END
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
