C for ODF3_1 10/04/2012
 
      SUBROUTINE librations(key,par,parin)
c   
          IMPLICIT DOUBLE PRECISION (A-H),DOUBLE PRECISION (O-Z)
  
       include 'NumParam.inc'
       include 'DIMpar.inc'
c       include 'MATDIM.inc'

c
       if (key(6).eq.0) then
       return
       else
         par(16)=parin(16)
         par(17)=parin(17)
         par(18)=parin(18)
              do j=1,key(13)
              i=j-1
              par(NfirstSTV+6*i)=parin(NfirstSTV+6*i)
                  par(NfirstSTV+1+6*i)=parin(NfirstSTV+1+6*i)
                  par(NfirstSTV+2+6*i)=parin(NfirstSTV+2+6*i)
              enddo
       endif
c
          if (key(6).eq.1)then
c low angular  oscillations around g-axes
                 call librSin3(key,par,parin)
          endif
          if (key(6).eq.2) then
c limited oscillations around g-axes (analog Griffits)
c uniform distribution into interval -alfa - +alfa
             call Grif3(key,par,parin)
          endif
          if (key(6).eq.3) then
c limited oscillations around arbitrary axes(analog Timofeev)
             call Tim3(key,par,parin)
          endif
c          if (key(6).eq.4) then
c             call Compl(key,par,parin)
c          endif

      return
      end
c##############################################################################
      SUBROUTINE librSin3(key,par,parin)
c   
          IMPLICIT DOUBLE PRECISION (A-H),DOUBLE PRECISION (O-Z)

       include 'NumParam.inc'
       include 'DIMpar.inc'

c      include 'MATDIM.inc'

      dimension DHin(MAXNUCL,3)

      Slibx=par(19)
      Sliby=par(20)
      Slibz=par(21)
      gxxin=parin(16)
      gyyin=parin(17)
      gzzin=parin(18)
              do j=1,key(13)
              i=j-1
              DHin(j,1)=parin(NfirstSTV+6*i)
                  DHin(j,2)=parin(NfirstSTV+1+6*i)
                  DHin(j,3)=parin(NfirstSTV+2+6*i)
              enddo
c
      par(16)=gxxin+(gzzin-gxxin)*Sliby+(gyyin-gxxin)*Slibz
      par(17)=gyyin+(gzzin-gyyin)*Slibx+(gxxin-gyyin)*Slibz
      par(18)=gzzin+(gyyin-gzzin)*Slibx+(gxxin-gzzin)*Sliby      
c
              do j=1,key(13)
              i=j-1
      par(NfirstSTV+6*i)=DHin(j,1)+(DHin(j,3)-DHin(j,1))*Sliby
     #        +(DHin(j,2)-DHin(j,1))*Slibz
      par(NfirstSTV+1+6*i)=DHin(j,2)+(DHin(j,3)-DHin(j,2))*Slibx
     #        +(DHin(j,1)-DHin(j,2))*Slibz
      par(NfirstSTV+2+6*i)=DHin(j,3)+(DHin(j,2)-DHin(j,3))*Slibx
     #        +(DHin(j,1)-DHin(j,3))*Sliby      
                ENDDO
c
       return
      end
C ##################################################
        SUBROUTINE Tim3(key,par,parin)
        IMPLICIT DOUBLE PRECISION (A-H),DOUBLE PRECISION (O-Z)

       include 'NumParam.inc'
       include 'DIMpar.inc'
c       include 'MATDIM.inc'

       dimension U(3,3),FiTePsi(3)
      double precision PI
      parameter (PI=3.1415926535897932384626433832795D0)
       parameter (coe=PI/180.d0)
c limited oscillations around arbitrary axes(analog Timofeev)
        FiTePsi(1)=par(24)*coe
        FiTePsi(2)=par(23)*coe
        FiTePsi(3)=par(22)*coe
        call EulerMat(FiTePsi,s2,c2,u)

c  around X axis of librational sistem
      ALib2Alf=par(19)*coe
      if (ALib2Alf.ne.0.d0)then
c equations (19) from Timofeev's articles
        Q1=dsin(2.d0*ALib2Alf)/2.d0/ALib2Alf
          Q1= ( 1.d0 + Q1) /2.d0
          Q2= DSin(ALib2Alf) / ALib2Alf - Q1
        Q3= 1.d0 - DSin(ALib2Alf) /ALib2Alf - Q2
        Q4= DSin( 2.d0 *ALib2Alf) / 2.d0 /ALib2Alf
        Q4= ( 1.d0 - Q4) / 2.d0
c equations (14) from Timofeev's articles
       SXR=(3.d0*u(1,1)*u(1,1)-1.d0)/2.d0       
       SYR=(3.d0*u(1,2)*u(1,2)-1.d0)/2.d0       
       SZR=(3.d0*u(1,3)*u(1,3)-1.d0)/2.d0  
       call tim1(parin(16),parin(17),parin(18),
     *           par(16),par(17),par(18),
     *           SXR,SYR,SZR,Q1,Q2,Q3,Q4)      
        do j=1,key(13)
           jj=j-1
           call tim1(parin(NfirstSTV+6*jj),parin(NfirstSTV+1+6*jj),
     *               parin(NfirstSTV+2+6*jj),par(NfirstSTV+6*jj), 
     *               par(NfirstSTV+1+6*jj),  par(NfirstSTV+2+6*jj),
     *               SXR,SYR,SZR,Q1,Q2,Q3,Q4)      
        enddo
      else
         par(16)=parin(16)
         par(17)=parin(17)
         par(18)=parin(18)
         do j=1,key(13)
           jj=j-1
           par(NfirstSTV+6*jj)=parin(NfirstSTV+6*jj)
           par(NfirstSTV+1+6*jj)=parin(NfirstSTV+1+6*jj)
           par(NfirstSTV+2+6*jj)=parin(NfirstSTV+2+6*jj)
         enddo
      endif
c  around Y axis of librational sistem
      ALib2Alf=par(20)*coe
      if (ALib2Alf.ne.0.d0)then
        Q1=dsin(2.d0*ALib2Alf)/2.d0/ALib2Alf
          Q1= ( 1.d0 + Q1) /2.d0
          Q2= DSin(ALib2Alf) / ALib2Alf - Q1
        Q3= 1.d0 - DSin(ALib2Alf) /ALib2Alf - Q2
        Q4= DSin( 2.d0 *ALib2Alf) / 2.d0 /ALib2Alf
        Q4= ( 1.d0 - Q4) / 2.d0
       SXR=(3.d0*u(2,1)*u(2,1)-1.d0)/2.d0       
       SYR=(3.d0*u(2,2)*u(2,2)-1.d0)/2.d0       
       SZR=(3.d0*u(2,3)*u(2,3)-1.d0)/2.d0  
       call tim1(par(16),par(17),par(18),
     *           res1,res2,res3,
     *           SXR,SYR,SZR,Q1,Q2,Q3,Q4)      
      par(16)=res1
      par(17)=res2
      par(18)=res3
        do j=1,key(13)
           jj=j-1
           call tim1(par(NfirstSTV+6*jj),par(NfirstSTV+1+6*jj),
     *               par(NfirstSTV+2+6*jj),res1,res2,res3,
     *               SXR,SYR,SZR,Q1,Q2,Q3,Q4)
           par(NfirstSTV+6*jj)=res1
             par(NfirstSTV+1+6*jj)=res2
             par(NfirstSTV+2+6*jj)=res3
        enddo
      endif
c  around Z axis of librational sistem
      ALib2Alf=par(21)*coe
      if (ALib2Alf.ne.0.d0)then
        Q1=dsin(2.d0*ALib2Alf)/2.d0/ALib2Alf
          Q1= ( 1.d0 + Q1) /2.d0
          Q2= DSin(ALib2Alf) / ALib2Alf - Q1
        Q3= 1.d0 - DSin(ALib2Alf) /ALib2Alf - Q2
        Q4= DSin( 2.d0 *ALib2Alf) / 2.d0 /ALib2Alf
        Q4= ( 1.d0 - Q4) / 2.d0
       SXR=(3.d0*u(3,1)*u(3,1)-1.d0)/2.d0       
       SYR=(3.d0*u(3,2)*u(3,2)-1.d0)/2.d0       
       SZR=(3.d0*u(3,3)*u(3,3)-1.d0)/2.d0  
       call tim1(par(16),par(17),par(18),
     *           res1,res2,res3,
     *           SXR,SYR,SZR,Q1,Q2,Q3,Q4)      
      par(16)=res1
      par(17)=res2
      par(18)=res3
        do j=1,key(13)
           jj=j-1
           call tim1(par(NfirstSTV+6*jj),par(NfirstSTV+1+6*jj),
     *               par(NfirstSTV+2+6*jj),res1,res2,res3,
     *               SXR,SYR,SZR,Q1,Q2,Q3,Q4)
           par(NfirstSTV+6*jj)=res1
             par(NfirstSTV+1+6*jj)=res2
             par(NfirstSTV+2+6*jj)=res3
        enddo
      endif
      return
      end
C ###################################################
           SUBROUTINE tim1(valin1,valin2,valin3,
     *                       valres1,valres2,valres3,
     *                       SXR,SYR,SZR,Q1,Q2,Q3,Q4)  
          IMPLICIT DOUBLE PRECISION (A-H),DOUBLE PRECISION (O-Z)
c equations for oscillation around arbitrary axis 
c equations (16'), (17') and (18') from Timofeev's articles
       parameter (dvetret=2.d0/3.d0)
        QQ3=(valin1+valin2+valin3)/3.d0
      QQ3=QQ3+dvetret*(valin1*SXR+valin2*SYR+valin3*SZR)
      QQ3=QQ3*Q3/3.d0
      sl1=(Q1+dvetret*Q2*(2.d0*SXR+1.d0))*valin1
      sl2=QQ3*(2.d0*SXR+1.d0)
      sl3=Q4*((2.d0*SYR+1.d0)*valin3+(2.d0*SZR+1.d0)*valin2)/3.d0
      valres1=sl1+sl2+sl3
c
      sl1=(Q1+dvetret*Q2*(2.d0*SYR+1.d0))*valin2
      sl2=QQ3*(2.d0*SYR+1.d0)
      sl3=Q4*((2.d0*SXR+1.d0)*valin3+(2.d0*SZR+1.d0)*valin1)/3.d0
      valres2=sl1+sl2+sl3
c
      sl1=(Q1+dvetret*Q2*(2.d0*SZR+1.d0))*valin3
      sl2=QQ3*(2.d0*SZR+1.d0)
      sl3=Q4*((2.d0*SYR+1.d0)*valin1+(2.d0*SXR+1.d0)*valin2)/3.d0
      valres3=sl1+sl2+sl3
      return
      end
C ##################################################
      SUBROUTINE grif3(key,par,parin)   
       IMPLICIT DOUBLE PRECISION (A-H),DOUBLE PRECISION (O-Z)
      double precision PI
      parameter (PI=3.1415926535897932384626433832795D0)
       parameter (coe=PI/180.d0)

       include 'NumParam.inc'
       include 'DIMpar.inc'
c       include 'MATDIM.inc'

        dimension parprom(NUMPAR)
       Logical Flag(MAXNUCL)
c
c if there are angles between g- and A- tenzors, then Flag=.False.
         do j=1,key(13)
           jj=j-1
          if (abs(parin(NfirstSTV+3+6*jj))+abs(parin(NfirstSTV+4+6*jj))+
     +     abs(parin(NfirstSTV+5+6*jj)).EQ.0) then
           Flag(j)=.True.
           else
           Flag(j)=.False.
          endif
         enddo

      ALib2Alf=par(19)*coe*2.d0
      if (ALib2Alf.ne.0.d0)then
         P1=dsin(ALib2Alf)/ALib2Alf
         call grif1(P1,parin(17),parin(18),par(17),par(18))
         par(16)=parin(16)
         do j=1,key(13)
           jj=j-1
           if (Flag(j)) then
         call grif1(P1,parin(NfirstSTV+1+6*jj),parin(NfirstSTV+2+6*jj),
     *              par(NfirstSTV+1+6*jj),  par(NfirstSTV+2+6*jj))
               par(NfirstSTV+6*jj)=parin(NfirstSTV+6*jj)                   
           endif
         enddo 
      else
         par(16)=parin(16)
         par(17)=parin(17)
         par(18)=parin(18)
         do j=1,key(13)
           jj=j-1
           par(NfirstSTV+6*jj)=parin(NfirstSTV+6*jj)
           par(NfirstSTV+1+6*jj)=parin(NfirstSTV+1+6*jj)
           par(NfirstSTV+2+6*jj)=parin(NfirstSTV+2+6*jj)
         enddo
      endif
      ALib2Alf=par(20)*coe*2.d0
      if (ALib2Alf.ne.0.d0)then
         P1=dsin(ALib2Alf)/ALib2Alf
         call grif1(P1,par(18),par(16),res2,res3)
         par(18)=res2
         par(16)=res3
         do j=1,key(13)
           jj=j-1
           if (Flag(j)) then
              call grif1(P1,par(NfirstSTV+2+6*jj),par(NfirstSTV+6*jj),
     *                   res2,res3)
              par(NfirstSTV+2+6*jj)=res2
              par(NfirstSTV+6*jj)=res3
           endif
         enddo
      endif
      ALib2Alf=par(21)*coe*2.d0
      if (ALib2Alf.ne.0.d0)then
         P1=dsin(ALib2Alf)/ALib2Alf
         call grif1(P1,par(16),par(17),res2,res3)
         par(16)=res2
         par(17)=res3
         do j=1,key(13)
            jj=j-1
            if (Flag(j)) then
                call grif1(P1,par(NfirstSTV+6*jj),par(NfirstSTV+1+6*jj),
     *                     res2,res3)
                par(NfirstSTV+6*jj)=res2
                par(NfirstSTV+1+6*jj)=res3
            endif
         enddo
      endif
c if there are angles between g- and A- tenzors
         do jprom=19,24
            parprom(jprom)=par(jprom)
         enddo
         do j=1,key(13)
            jj=j-1
            if (.NOT.Flag(j)) then
               do jprom=NfirstSTV,NfirstSTV+5
                  parprom(jprom+6*jj)=par(jprom+6*jj)
               enddo
               parprom(22)=par(NfirstSTV+3+6*jj)
               parprom(23)=par(NfirstSTV+4+6*jj)
                 parprom(24)=par(NfirstSTV+5+6*jj)
                       call Tim3(key,parprom,parin)
               par(NfirstSTV+6*jj)=parprom(NfirstSTV+6*jj)
               par(NfirstSTV+1+6*jj)=parprom(NfirstSTV+1+6*jj)
               par(NfirstSTV+2+6*jj)=parprom(NfirstSTV+2+6*jj)
           endif
         enddo
      return
      end
C ##################################################
           SUBROUTINE grif1(P1,valin2,valin3,valres2,valres3)  
          IMPLICIT DOUBLE PRECISION (A-H),DOUBLE PRECISION (O-Z)
c formula for oscillation around first axis 
c analog the Griffits equations  
      valres2=(valin2*(1.d0+P1)+valin3*(1.d0-P1))/2.D0
      valres3=(valin2*(1.d0-P1)+valin3*(1.d0+P1))/2.D0
      return
      end
C ##################################################
