C for ODF3_1 10/04/2012

c     Version 1.5  5/2/94
c----------------------------------------------------------------------
c                    =========================
c                       subroutine GCONVL
c                    =========================
c
c     Convolute given spectrum with a Gaussian lineshape having
c     a specified derivative peak-to-peak linewidth
c     Changed by AXV 20.03.02
c     Now it convolute given spectrum with a Gaussian
c     or Lorenzian line depending on KeyLine
c----------------------------------------------------------------------
      subroutine gconvl( spectr,wline,dfld,nfld )
      implicit none
       include 'NumParam.inc' 
c
      integer nfld
      double precision spectr(nfld),wline,dfld
c
      integer i,k,nft,no2
      double precision df,f,g,gnorm
c
      double precision PI
      parameter (PI=3.1415926535897932384626433832795D0)
c
      double precision tmpdat
      common /temp/ tmpdat(2,NUMPOINT)
c
      double precision EIGHT,EPS,ONE,TWO,THIRD,ZERO,SQR3
      parameter ( EIGHT=8.0D0,ONE=1.0D0,TWO=2.0D0,ZERO=0.0D0,
     #            EPS=1.0D-6,THIRD=0.3333333333333333D0,
     #            SQR3=1.732050807568877D0 )
c
c######################################################################
c
      if (wline.lt.EPS) return
c
c      ----------------------------
c      Find next largest power of 2
c      ----------------------------
       nft=2
    1  nft=nft+nft
          if (nft.lt.nfld) goto 1    
c
c      -----------------------------------------------
c       Store calculation in tmpdat, zero-pad, and FFT
c      -----------------------------------------------
      do i=1,nfld
         tmpdat(1,i)=spectr(i)
c         tmpdat(2,i)=spectr(2,i)
      end do
      do i=nfld+1,nft
         tmpdat(1,i)=ZERO
         tmpdat(2,i)=ZERO
      end do
c
      call fft( tmpdat,nft,+1 )
c
      no2=nft/2
      df=TWO*PI/(dfloat(nft)*dfld)
      gnorm=ONE/dfloat(nft)
      tmpdat(1,1)=tmpdat(1,1)*gnorm
      tmpdat(2,1)=tmpdat(2,1)*gnorm
      f=df
c     --------------------------------------------------
c     Convolute with Gaussian function by multiplying in
c     with a Gaussian in Fourier space.
c     --------------------------------------------------
      do i=2,no2
         k=nft-i+2
         g=gnorm*dexp( -(f*wline)**2/EIGHT )
         tmpdat(1,i)=tmpdat(1,i)*g
         tmpdat(2,i)=tmpdat(2,i)*g
         tmpdat(1,k)=tmpdat(1,k)*g
         tmpdat(2,k)=tmpdat(2,k)*g
         f=f+df
      end do
      k=no2+1
      g=gnorm*dexp( -(f*wline)**2/EIGHT )

 13   tmpdat(1,k)=tmpdat(1,k)*g
      tmpdat(2,k)=tmpdat(2,k)*g
c
      call fft(tmpdat,nft,-1)
c
      do i=1,nfld
         spectr(i)=tmpdat(1,i)
      end do
c
      return
      end

